import com.javageeks.classloader.FileSystemClassLoader;

public class ClassLoadTest
{
    public static void main(String[] args)
        throws Exception    // cheap way to avoid catch()ing Exceptions
    {
        // The idea is simple: load a .class and run() it, then pause for 10 
        // seconds before doing it again. If you modify the .class file during
        // the pause, then the new ClassLoader should pick up the modification
        // and execute the new file instead of the old one
        //
        System.out.println(args.length);
        
        if (args.length > 0)
        {
            if (args[0].startsWith("-unique"))
            {
                // We want to use a unique ClassLoader isntance on each
                // loop
                //
                while (true)
                {
                    FileSystemClassLoader fscl = 
                        new FileSystemClassLoader("./TestDir");
                    Class c = fscl.loadClass(args[1]);
                    Object o = c.newInstance();
                    System.out.println(o.toString());
                    
                    System.out.println("Sleeping for 15 seconds....");
                    Thread.sleep(15*1000);
                }
            }
            else
            {
                // We want to use the same ClassLoader instance on each
                // loop
                //
                FileSystemClassLoader fscl =
                    new FileSystemClassLoader("./TestDir");
                while (true)
                {
                    Class c = fscl.loadClass(args[0]);
                    Object o = c.newInstance();
                    System.out.println(o.toString());
                    
                    System.out.println("Sleeping for 15 seconds....");
                    Thread.sleep(15*1000);
                }
            }
        }
        else
        {
            System.out.println("Usage: java ClassLoadTest [-unique] classname");
            System.out.println("\tWhile the code is running, open a new command");
            System.out.println("\tshell and execute TestDir's SWITCH.BAT.");
            System.out.println("\tThis will switch Hello.class from one version");
            System.out.println("\tto the other.");
            return;
        }
    }
}    