public class DynamicCode
{
    public static void main(String[] args)
        throws Exception	// a lazy way to not deal with Exceptions
    {
        // Get the name of the class to load and execute off the command
        // line's first argument (after "java DynamicCode")
        //
        if (args.length < 1)
        {
            System.out.println("Usage: java DynamicCode <class to run>");
            System.exit(-1);
        }

        Class cls = Class.forName(args[0]);
        Object obj = cls.newInstance();

        // Cast the Object to a Runnable so we can invoke the run() method
        // on it
        //
        Runnable r = (Runnable) obj;
        r.run();
    }
}