import java.net.URL;
import java.net.URLClassLoader;

public class FileURLClient
{
    /**
     * Attempt to instantiate an instance of the class
     * Hello, found in the subdirectory "subdir" from the
     * chap02 directory
     */
    public static void main(String[] args)
        throws Exception
    {
        // FileURLClient comes in two forms: one that loads from the
        // subdirectory "subdir", and one that loads from the .jar
        // file, "subdir.jar" in the current directory. Use one or
        // the other forms of the URL array below to decide which
        // one you'd like to run.
        //
        URL[] urlArray =
        {
            //new java.io.File("subdir.jar").toURL()
                // For loading-from-subdir.jar, uncomment the
                // above line and comment out the below line

            new java.io.File("subdir/").toURL()
                // For loading-from-subdirectory-subdir,
                // comment out the first line and uncomment
                // out this one
        };
        
        URLClassLoader ucl = new URLClassLoader(urlArray);
        Object obj = 
            ucl.loadClass("Hello").newInstance();
            
        // Hello should print "Hello" to the System.out stream
    }
}
