public class ReflectingDynamicCode
{
    public static void main(String[] args)
        throws Exception	// a lazy way to not deal with Exceptions
    {
        // Get the name of the class to load and execute off the command
        // line's first argument (after "java DynamicCode")
        //
        if (args.length < 1)
        {
            System.out.println("Usage: java DynamicCode <class to run>");
            System.exit(-1);
        }

        Class cls = Class.forName(args[0]);
        Object obj = cls.newInstance();

        // Reflect on the Class; find the method named "run" that takes
        // no arguments and returns no return value
        //
        java.lang.reflect.Method[] methods = cls.getMethods();
        for (int i=0; i<methods.length; i++)
        {
            System.out.println("Checking name of " + cls.getName()
                + "." + methods[i].getName());
            if (methods[i].getName().equals("run"))
            {
                if (methods[i].getReturnType().equals(java.lang.Void.TYPE) &&
                    methods[i].getParameterTypes().length == 0)
                {
                    // methods[i] is the Method that corresponds to the
                    // method "void run()". Call it.
                    //
                    Object ret = methods[i].invoke(obj, null);
                    if (ret != null)
                        System.out.println("??? run()'s not supposed to " +
                            "return me something!");
                }
            }
        }

    }
}