public class TestSuite
{
    public TestSuite(String classname)
    {
        try
        {
            // Load the Class given by classname
            //
            Class cls = Class.forName(classname);
            
            // See if it exposes a "void test()" method; if so, call it
            //
            java.lang.reflect.Method[] methods = cls.getMethods();
            for (int i=0; i<methods.length; i++)
            {
                //System.out.println("Checking name of " + cls.getName()
                //    + "." + methods[i].getName());
                if (methods[i].getName().equals("test"))
                {
                    if (methods[i].getReturnType().equals(java.lang.Void.TYPE) &&
                        methods[i].getParameterTypes().length == 0)
                    {
                        // methods[i] is the Method that corresponds to the
                        // method "void run()". Call it.
                        //
                        Object ret = methods[i].invoke(null, null);
                        if (ret != null)
                            System.out.println("??? test()'s not supposed to " +
                                "return me something!");
                    }
                }
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }
    
    
    public static void main(String[] args)
    {
        // Iterate through each arg, attempting to load that class
        // and execute it's test() method
        //
        for (int i=0; i<args.length; i++)
        {
            new TestSuite(args[i]);
        }
    }

    public static void test ()
    {
        System.out.println("Running test....");

        System.out.println("Test complete!");
    }
}    