import com.javageeks.gjas.ConfigProperties;
import com.javageeks.gjas.ServerManager;
import com.javageeks.gjas.Service;


/**
 * HelloAgainService
 */
public class HelloAgainService
    implements Service, Runnable
{
    // Internal members
    //    
    private int m_interval = 5; // in seconds
    private boolean m_paused = false;
    private Thread m_thread = null;
    private String m_message = "Hello, again!";
    
    private String m_state = STOPPED;
    private static int s_instanceCt = 0;


    public HelloAgainService()
    {
        m_thread = new Thread(this);
    }

    //
    // Service interface methods
    //    
    public void start()
        throws Exception
    {
        // We're starting
        //
        m_state = STARTING;

        // Start our thread
        //
        m_thread.start();
        
        // We're running
        //
        m_state = RUNNING;
    }
    public void stop()
        throws Exception
    {
        // We're stopping
        //
        m_state = STOPPING;

        // Stop our thread
        //
        m_thread.interrupt();
        m_thread.join();
            // Wait for thread to finish, which releases us                
        
        // We've stopped
        //
        m_state = STOPPED;
    }
    public void pause()
        throws Exception
    {
        // We're pausing
        //
        m_state = PAUSING;

        // Set the 'paused' member to true, which causes the run() loop
        // below to skip its message
        //
        m_paused = true;
        
        // We've paused
        //
        m_state = PAUSED;
    }
    public void resume()
        throws Exception
    {
        // We're resuming
        //
        m_state = RESUMING;
        
        // Set the 'paused' member to false, which causes the run()
        // loop below to display its message
        //
        m_paused = false;
        
        // We've started up again
        //
        m_state = RUNNING;
    }
    	

    public String getState()
    {
        return m_state;
    }


    public String getInstanceID()
        throws Exception
    {
        return getClass() + ":1.0:" + System.currentTimeMillis();
    }
    
    
    public ConfigProperties getConfigInfo()
    {
        return new ConfigProperties();
    }
    public void setConfigInfo(ConfigProperties configInfo)
    {
        // Do nothing
    }


    //
    // Runnable interface methods
    //
    /**
     * Method called by Thread.start()
     */
    public void run()
    {
        try
        {
            while (!Thread.currentThread().isInterrupted())
            {
                Thread.sleep(m_interval * 1000);
                if (!m_paused)
                    System.out.println(m_message);
            }
        }
        catch (InterruptedException ex)
        {
            System.out.println("Going away now....");
        }
    }
}

