import java.util.Iterator;
import com.javageeks.gjas.ConfigProperty;
import com.javageeks.gjas.ConfigProperties;
import com.javageeks.gjas.Service;
import com.javageeks.gjas.ServerManager;

public class HelloService
    implements Service
{
    // Constants
    private static final String MESSAGE_PROP = "message";
    private static final String REPEAT_PROP = "repeat";
    
    // Internal data
    //
    private String m_state = STOPPED;
    private ConfigProperty propMessage = 
        new ConfigProperty(MESSAGE_PROP, 
                           "Hello, world, from TestService",
                           "Message to display");
    private ConfigProperty propRepeat = 
        new ConfigProperty(REPEAT_PROP, 
                           new Integer(5),
                           "Number of messages to display");
    
    private ConfigProperties configInfo = 
        new ConfigProperties(new ConfigProperty[]
        {
            propMessage,
            propRepeat
        });

    
    /**
     *
     */
    public HelloService()
    { }
    
    
    /**
     *
     */
    public void start()
        throws Exception
    {
        // We're starting
        //
        m_state = STARTING;
    
        ServerManager.log("HelloService: start()");
        
        // Print out "Hello, world!"
        //
        for (int i=0; 
             i < ((Integer)propRepeat.getValue()).intValue();
             i++)
        {
            System.out.println("\t" + 
                               (String)propMessage.getValue());
        }
    
        // We're running
        //
        m_state = RUNNING;
    }
    public void stop()
        throws Exception
    {
        // We're stopping
        //
        m_state = STOPPING;
        
        ServerManager.log("HelloService: stop()");
        
        // We've stopped
        //
        m_state = STOPPED;
    }
    public void pause()
        throws Exception
    {
        // We're pausing
        //
        m_state = PAUSING;
        
        ServerManager.log("HelloService: pause()");
        
        // We've paused
        //
        m_state = PAUSED;
    }
    public void resume()
        throws Exception
    {
        // We're resuming
        //
        m_state = RESUMING;
        
        ServerManager.log("HelloService: resuming()");
        
        // We've started up again
        //
        m_state = RUNNING;
    }
        

    public String getState()
    {
        return m_state;
    }


    public String getInstanceID()
        throws Exception
    {
        return getClass() + ":" + "1.0" + ":"
            + System.currentTimeMillis();
    }

    
    /**
     * Return the ConfigProperties instance for this Service
     */
    public ConfigProperties getConfigInfo()
    {
        return configInfo;
    }
    /**
     * Set the ConfigProperties instance for this Service
     */
    public void setConfigInfo(ConfigProperties info)
    {
        configInfo.set(info);
    }
}
