package Employee;

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;


/**
 *
 */
/*
class RMIPerson
    implements IPerson
{
}

class RMIEmployee
    implements IEmployee
{
}

class RMIManager
    implements IManager
{
}

class RMIPosition
    implements IPosition
{
}

class RMIDepartment
    implements IDepartment
{
}
 
class RMIAddress
    implements IAddress
{
}

class RMIEMail
    implements IEMail
{
}

class RMIPhone
    implements IPhone
{
}
*/



/**
 * RMIModel is a proxy to the RMIModelRemoteServer; all actual work
 * happens on that side of the connection, this side just passes the
 * arguments and gets back the results.
 */
public class RMIModel
    implements IEmployeeModel
{
    // Internal members
    //
    private IRMIModelRemoteInterface m_server;
    
    
    /**
     * Typesafe wrapper around Naming.lookup()
     */
    public static IRMIModelRemoteInterface lookup(String host)
    {
        try
        {
            String lookupName = "rmi://" + host +
                IRMIModelRemoteInterface.RMI_BINDING_NAME;
            return
                (IRMIModelRemoteInterface)Naming.lookup(lookupName);
        }
        catch (Exception ex)
        {
            return null;
        }
    }
    
    

    /**
     * Create IPerson object
     */
    public IPerson createPerson(
        String firstName, String middleName, String lastName,
        String ssn)
        throws BusinessLayerException, DuplicateObjectException
    {
        return m_server.remoteCreatePerson(firstName, middleName,
                                           lastName, ssn);
    }
    
    /**
     * Create IEmployee object
     */
    public IEmployee createEmployee(
        String firstName, String lastName, String middleName,
        String ssn, IPosition position, int salary)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IEmployee from IPerson
     */
    public IEmployee createEmployee(IPerson person, 
        IPosition position, int salary)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IManager object
     */
    public IManager createManager(
        String firstName, String lastName, String middleName,
        String ssn, IPosition position, int salary)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }

    /**
     * Create IManager from IEmployee
     */
    public IManager createManager(IEmployee employee)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IDepartment object
     */
    public IDepartment createDepartment(
        String name, IDepartment parent)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }
    
    /**
     * Create IPosition object
     */
    public IPosition createPosition(
        String title, String desc, int minSalary, int maxSalary)
        throws BusinessLayerException, DuplicateObjectException
    {
        return null;
    }



    /**
     * Query for all Persons
     */
    public IPerson[] findAllPersons()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Persons by last name
     */
    public IPerson[] findPersonsByLastName(String lastName)
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Persons by SSN
     */
    public IPerson[] findPersonsBySSN(String ssn)
        throws BusinessLayerException
    {
        return null;
    }

    /**
     * Query for all Employees
     */
    public IEmployee[] findAllEmployees()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Managers
     */
    public IManager[] findAllManagers()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Positions
     */
    public IPosition[] findAllPositions()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for all Departments
     */
    public IDepartment[] findAllDepartments()
        throws BusinessLayerException
    {
        return null;
    }
    
    /**
     * Query for "root" Department
     */
    public IDepartment findRootDepartment()
        throws BusinessLayerException
    {
        return null;
    }
        
        
        
    /**
     * Remove a Person from the system
     */
    public void removePerson(IPerson person)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }

    /**
     * Remove an Employee from the system
     */
    public void removeEmployee(IEmployee employee)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }

    /**
     * Remove a Manager from the system
     */
    public void removeManager(IManager manager)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }

    /**
     * Remove a Department from the system
     */
    public void removeDepartment(IDepartment dept)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }

    /**
     * Remove a Position from the system
     */
    public void removePosition(IPosition position)
        throws BusinessLayerException, IntegrityConstraintException,
            UnknownObjectException
    {
    }
}    