package Employee;

import ch.softwired.ibus.*;
import ch.softwired.ibus.util.*;
import java.util.Vector;
import java.util.Hashtable;



/**
 *
 */
public class iBusModelServer
{
    // Internal data
    private IEmployeeModel m_model;

    
    /**
     *
     */
    public iBusModelServer(IEmployeeModel model)
        throws Exception
    {
        m_model = model;

        // Set up IEmployeeModel Channels
        //
        Replyer personFindReplyer = 
            new Replyer(new Channel(new ChannelURL(
                "ibus://" + "/Person.find")));
        personFindReplyer.addRequestListener(new RequestListener()
        {
            public void handleRequestEvent(RequestEvent event)
            {
                String request = (String)event.getObject();
                ReplyPort rp = event.getReplyPort();
                if (request.equals(""))
                {
                    // Pull back everything
                    try
                    {
                        IPerson[] arr = m_model.findAllPersons();

                        Vector v = new Vector();
                        for (int i=0; i<arr.length; i++)
                        {
                            v.addElement(new iBusPerson(arr[i]));
                        }
                        rp.reply(v);
                    }
                    catch (Exception x)
                    {
                        try { rp.noReply(); }
                        catch (Exception ex) { }
                    }
                }
                else
                {
                    // Pull back IPerson requested
                    if (request.startsWith("SSN:"))
                    {
                    }
                    else if (request.startsWith("LastName:"))
                    {
                    }
                    else
                        try { rp.noReply(); }
                        catch (Exception ex) { }
                }
            }
        });

        // Park it until we're finished
        ThreadHelper.WAIT_UNTIL_EXIT.suspend();
    }


    /**
     *
     */


    /**
     *
     */
    public static void main (String args[])
        throws Exception
    {
        // Create an RDBMSModel to our local DB, then
        // wrap an iBusModelServer around it
        //
        Class.forName("jdbc.idbDriver");
        java.sql.Connection conn = 
            java.sql.DriverManager.getConnection(
                "jdbc:idb:employee.prp",
                new java.util.Properties());
        RDBMSModel rdbms_model = new RDBMSModel(conn);

        
        iBusModelServer ibus_server = 
            new iBusModelServer(rdbms_model);
    }
}
