#include <iostream>
#include <fstream>
using namespace std;

int main(int argc, char* argv[])
{
    // We want to code-gen our tools using the following template:
    char* codeGenTemplate1[] =
    {
        "#include <jni.h>\n",
        "\n",
        "// StdC++ headers\n",
        "#include <iostream>\n",
        "#include <fstream>\n",
        "#include <string>\n",
        "#include <vector>\n",
        "\n",
        "// Namespaces in use\n",
        "using namespace std;\n",
        "\n",
        "int main(int argc, char* argv[], char* env[])\n",
        "{\n",
        "   // Extract environment vars\n",
        "   //\n",
        "   string cmtree;\n",
        "   while (*env != 0)\n",
        "   {\n",
        "       string name;\n",
        "       string value;\n",
        "\n",
        "       char* iter = *env;\n",
        "       while (*iter != \'=\')\n",
        "       {\n",
        "           name += *iter;\n",
        "           iter++;\n",
        "       }\n",
        "       if (name == \"CMTREE\")\n",
        "       {\n",
        "           iter++;\n",
        "\n",
        "           while (*iter != 0)\n",
        "           {\n",
        "               value += *iter;\n",
        "               iter++;\n",
        "           }\n",
        "           cmtree = value;\n",
        "           //cout << \"CMTREE= \" << cmtree.c_str() << endl;\n",
        "       }\n",
        "\n",
        "       env++;\n",
        "   }\n",
        "\n",
        "   vector<string> jvm_argv;\n",
        "   string classname;\n",
        "   bool verbose = false;\n",
        "\n",
        "   // The remainder of the arguments are assumed to be command-line\n",
        "   // parameters to the Java class\n",
        "   int j;\n",
        "   for (j=1;j<argc;j++)\n",
        "       jvm_argv.push_back(argv[j]);\n",
        "\n",
        "\n",
        "    JavaVMInitArgs vm_args;\n",
        "    JavaVMOption options[4]; int n=0;\n",
        "\n",
        "    options[n++].optionString = \"-Djava.compiler=NONE\";\n",
        "               /* disable JIT */\n",
        "    char* classpath = new char[80];\n",
        "    strcat(classpath, \"-Djava.class.path=\");\n",
        "    strcat(classpath, cmtree.c_str());\n",
        "    options[n++].optionString = classpath;\n",
        "               /* user classes */\n",
        "    //options[n++].optionString = \"-Djava.library.path=c:\\mylibs\";\n",
        "               /* set native library path */\n",
        "    //options[n++].optionString = \"-verbose:jni\";\n",
        "               /* print JNI-related messages */\n",
        "\n",
        "    vm_args.version = JNI_VERSION_1_2;\n",
        "    vm_args.options = options;\n",
        "    vm_args.nOptions = n;\n",
        "    vm_args.ignoreUnrecognized = true;\n",
        "\n",
        "    /* Note that in JDK 1.2, there is no longer any need to call \n",
        "     * JNI_GetDefaultJavaVMInitArgs.  */\n",
        "    JavaVM* vm;\n",
        "    JNIEnv* jnienv;\n",
        "    jint res = JNI_CreateJavaVM(&vm, (void **)&jnienv, &vm_args);\n",
        "\n",
        "    // argv[1] is the Java class to load\n",
        "    jclass cls = jnienv->FindClass(",
        0
    };

    char* codeGenTemplate2[] = 
    {
        ");\n",
        "    if (!cls)\n",
        "    {\n",
        "        cout << ",
        0
    };
    
    char* codeGenTemplate3[] =
    {
        " << \".class not found\" << endl;\n",
        "        return -1;\n",
        "    }\n",
        "   jmethodID cls_main = jnienv->GetStaticMethodID(cls, \"main\", \"([Ljava/lang/String;)V\");\n",
        "   if (!cls_main)\n",
        "   {\n",
        "        cout << \"main(String[]) not found\" << endl;\n",
        "       return -1;\n",
        "   }\n",
        "\n",
        "    // Build args to main()\n",
        "   jvalue call_args[1];                // One argument to main: \"java.lang.String[] args\"\n",
        "\n",
        "   jclass cls_java_lang_String = jnienv->FindClass(\"java/lang/String\");\n",
        "   jobject defaultValue = jnienv->NewStringUTF(\"\");\n",
        "   jobjectArray args = jnienv->NewObjectArray(argc-1, cls_java_lang_String, defaultValue);\n",
        "\n",
        "   // Populate \"args\"\n",
        "   int i=0;\n",
        "   for (vector<string>::iterator iter = jvm_argv.begin(); \n",
        "        iter != jvm_argv.end();\n",
        "        iter++)\n",
        "   {\n",
        "       jstring str = jnienv->NewStringUTF((*iter).c_str());\n",
        "       jnienv->SetObjectArrayElement(args, i++, str);\n",
        "   }\n",
        "   call_args[0].l = args;\n",
        "\n",
        "   //\n",
        "   // Call \"main\"\n",
        "   //\n",
        "   jnienv->CallStaticVoidMethodA(cls, cls_main, call_args);\n",
        "\n",
        "   //\n",
        "   // Report any uncaught Java exceptions thrown from within the JVM\n",
        "   //\n",
        "   jthrowable ex;\n",
        "   if ((ex = jnienv->ExceptionOccurred()) != NULL)\n",
        "   {\n",
        "       jnienv->ExceptionDescribe();\n",
        "   }\n",
        "\n",
        "   //\n",
        "   // Clean up\n",
        "   //\n",
        "   vm->DestroyJavaVM();\n",
        "\n",
        "    return 0;\n",
        "}\n",
        0
    };

    string cppFilename(argv[1]);
    cppFilename += ".cpp";
    ofstream out(cppFilename.c_str());
    for (char** iter = codeGenTemplate1; *iter != 0; iter++)
        out << *iter;
    out << "\"" << argv[1] << "\"";
    for (iter = codeGenTemplate2; *iter != 0; iter++)
        out << *iter;
    out << "\"" << argv[1] << "\"";
    for (iter = codeGenTemplate3; *iter != 0; iter++)
        out << *iter;

    return 0;
}    