#include "JPrimes.h"

#include <windows.h>
#include <stdlib.h>

// Basic scaffolding that must be in place for every Win32 native library
//
DWORD WINAPI DllEntryPoint(HINSTANCE, DWORD, LPVOID)
{
	return TRUE;
}

// Prototypes/stubs taken from javah-generated NativeHello.h
//
/*
 * Class:     JPrimes
 * Method:    nativeCalculatePrimes
 * Signature: (I)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_JPrimes_nativeCalculatePrimes(JNIEnv* env, jobject, jint stop)
{
	char* tmpbuffer = new char[stop];
	::memset(tmpbuffer, 0, stop);
	
	// Algorithm cribbed from Sedgewick's "Algorithms in C++"
	int i, j;
	int* a = new int[stop + 1];
	
	for (a[1]=0, i=2; i<= stop; i++)
		a[i] = 1;
	for (i=2; i<stop/2; i++)
		for (j=2; j<=stop/i; j++)
			a[i*j] = 0;
	for (i=1; i<=stop; i++)
		if (a[i])
		{
			char stringifiedI[10];
			itoa(i, stringifiedI, 10);
			strcat(tmpbuffer, stringifiedI);
			strcat(tmpbuffer, " ");
		}

	delete [] a;

	// Convert to Java java.lang.String object	
	jstring primes = env->NewStringUTF(tmpbuffer);
	return primes;
}

