#ifndef __JAVAGEEKS_JVMIMPL_H
#define __JAVAGEEKS_JVMIMPL_H

// JNI headers
#include <jni.h>


// Wrap everything up in a namespace
namespace JavaGeeks
{


// Wrap in a sub-namespace
namespace JNI
{

/*
 *
 */
class JVMImpl
{
    // Object lifetime mgmt
    //
public:
    static JVMImpl* getImpl();
        // Only means by which an implementation object can be 
        // obtained; this preserves portability
protected:
    JVMImpl();
    virtual ~JVMImpl();
        // Marked "protected" to allow subclasses to have access
private:
    JVMImpl(const JVMImpl& src);
    void operator=(const JVMImpl& src);
        // Disallow copying of JVMImpl instances


    // API
    //
public:
    virtual bool loadJVM(const char* JVMType) = 0;
    virtual jint createJavaVM(JavaVM**, void** env, void* args) = 0;
    virtual jint getDefaultJavaVMInitArgs(void* env) = 0;
};


};  // end namespace "JavaGeeks::JNI"

};  // end namespace "JavaGeeks"


#endif
