#include "Signal.h"

#include <iostream>
using namespace std;

#include <signal.h>

JNIEnv* g_envPtr;
jobject g_obj;

// Internal signal handler
void signalHandler(int sig)
{
    cout << "signalHandler called with value " << sig << endl;

    // We have to attach this thread to the JVM
    JavaVM** vmBuff = new JavaVM*[1];
    jsize bufLen = 1;
    jsize numVMs;
    jint i = JNI_GetCreatedJavaVMs(vmBuff, bufLen, &numVMs);

    if (numVMs > 0)
    {
        JNIEnv* envPtr;
        vmBuff[0]->AttachCurrentThread((void**)&envPtr, 0);
        jclass cls = envPtr->FindClass("Signal");
        jmethodID methodID = envPtr->GetStaticMethodID(cls, "signalSent", "()V");
        envPtr->CallStaticVoidMethod(cls, methodID);
    }
    else
        cout << "No JavaVMs created?!?" << endl;

    cout << "ready to return " << endl;
}    

/*
 * Class:     Signal
 * Method:    setSignalHandler
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_Signal_setSignalHandler
    (JNIEnv* env, jobject thisPtr)
{
    // Establish JNI globals
    g_envPtr = env;
    g_obj = thisPtr;

    // Set signal handler
    for (int i=0; i<63; i++)
        signal(i, signalHandler);
}
