#include "com_javageeks_net_NamedPipeInputStream.h"

#include <windows.h>

#include <iostream>
using namespace std;

/*
 * Class:     com_javageeks_net_NamedPipeInputStream
 * Method:    nativeAvailable
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_com_javageeks_net_NamedPipeInputStream_nativeAvailable
    (JNIEnv* env, jclass, jint namedPipe)
{
    int debug = (getenv("_JAVAGEEKS_DEBUG") != 0);

    HANDLE hPipe = (HANDLE)namedPipe;

    // Not sure what to do here....
}

/*
 * Class:     com_javageeks_net_NamedPipeInputStream
 * Method:    nativeRead
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_com_javageeks_net_NamedPipeInputStream_nativeRead__I
    (JNIEnv* env, jclass, jint namedPipe)
{
    int debug = (getenv("_JAVAGEEKS_DEBUG") != 0);

    HANDLE hPipe = (HANDLE)namedPipe;

    // Read one character

    return 1;
}

/*
 * Class:     com_javageeks_net_NamedPipeInputStream
 * Method:    nativeRead
 * Signature: (I[B)I
 */
JNIEXPORT jint JNICALL Java_com_javageeks_net_NamedPipeInputStream_nativeRead__I_3B
    (JNIEnv* env, jclass, jint namedPipe, jbyteArray bytes)
{
    int debug = (getenv("_JAVAGEEKS_DEBUG") != 0);

    HANDLE hPipe = (HANDLE)namedPipe;

    // Read bytes.length characters
    DWORD arrayLength = env->GetArrayLength(bytes);
    DWORD nRead;
    CHAR* recvArray = new CHAR[arrayLength];

    if (!::ReadFile(hPipe, recvArray, arrayLength, &nRead, NULL))
    {
        if (debug)
        {
            cout << "ERROR: Unable to read from named pipe" << endl;
        }
    }

    // recvArray now holds the named pipe data; transfer it to
    // the 'bytes' array
    env->SetByteArrayRegion(bytes, 0, nRead, (jbyte*)recvArray);

    return nRead;
}

