package com.javageeks.gjas;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 *
 */
public class ConfigProperties
{
    // Internal data
    //
    private Map map = new HashMap();


    /**
     *
     */
    public ConfigProperties()
    { }
    /**
     *
     */
    public ConfigProperties(Map map)
    {
        this.map = map;
    }
    /**
     *
     */
    public ConfigProperties(ConfigProperty[] properties)
    {
        for (int i=0; i<properties.length; i++)
        {
            map.put(properties[i].getName(), properties[i]);
        }
    }
    /**
     *
     */
    public ConfigProperties(ConfigProperties src)
    {
        try
        {
            map.putAll(src.map);
        }
        catch (UnsupportedOperationException uoe)
        {
            // Should never happen--we're using HashMap internally,
            // and HashMap supports everything in Map
        }
        catch (ClassCastException cce)
        {
            // Should never happen
        }
        catch (IllegalArgumentException iae)
        {
            // Ditto
        }
        catch (NullPointerException npe)
        {
            // How can it be null?
        }
    }
    /**
     *
     */
    public ConfigProperties(ConfigProperties src, ConfigProperty[] properties)
    {
        try
        {
            // Store ConfigProperty instances in 'src'
            map.putAll(src.map);
        
            // Store ConfigProperty instances in 'properties'
            for (int i=0; i<properties.length; i++)
            {
                map.put(properties[i].getName(), properties[i]);
            }
        }
        catch (UnsupportedOperationException uoe)
        {
            // Should never happen--we're using HashMap internally,
            // and HashMap supports everything in Map
        }
        catch (ClassCastException cce)
        {
            // Should never happen
        }
        catch (IllegalArgumentException iae)
        {
            // Ditto
        }
        catch (NullPointerException npe)
        {
            // How can it be null?
        }
    }


    /**
     *
     */
    public ConfigProperty get(String name)
    {
        return (ConfigProperty)map.get(name);
    }
    /**
     *
     */
    public Serializable getValue(String name)
    {
        return ((ConfigProperty)map.get(name)).getValue();
    }
    /**
     *
     */
    public void set(String name, Serializable value)
    {
        ((ConfigProperty)map.get(name)).setValue(value);
    }
    /**
     *
     */
    public void set(ConfigProperty prop)
    {
        map.put(prop.getName(), prop);
    }
    /**
     *
     */
    public void set(ConfigProperties props)
    {
        for (Iterator iter = props.properties(); iter.hasNext(); )
        {
            ConfigProperty prop = (ConfigProperty)iter.next();
            map.put(prop.getName(), prop);
        }
    }


    /**
     *
     */
    public void remove(String name)
    {
        map.remove(name);
    }
    /**
     *
     */
    public void remove(ConfigProperty prop)
    {
        remove(prop.getName());
    }


    /**
     *
     */
    public Iterator properties()
    {
        return map.values().iterator();
    }
}
