package com.javageeks.gjas;

import java.rmi.RemoteException;
import com.javageeks.classloader.ClassLoaderStrategy;

/**
 *
 */
public interface IRemoteServerManager
    extends java.rmi.Remote
{
    //=====================================================
    // These methods provide surrogate access for ServerManager
    // functionality

    /**
     *
     */
    public void remoteShutdown()
        throws RemoteException;
    

    /**
     *
     */
    public void remoteDeployService(String serviceName, 
                                    ClassLoaderStrategy strategy)
        throws RemoteException;
    /**
     *
     */
    public IServer remoteLoadService(Service svc)
        throws RemoteException;
    /**
     *
     */
    public IServer remoteLoadService(String svcName)
        throws RemoteException;
    /**
     *
     */
    public IServer remoteAddService(String svcName, 
                                    ConfigProperties args)
        throws RemoteException;
    /**
     *
     */
    public IServer remoteAddService(Service svc, 
                                    ConfigProperties args)
        throws RemoteException;
    /**
     *
     */
    public void remoteRemoveService(String instanceID)
        throws RemoteException;
    /**
     *
     */
    public void remoteKillService(String instanceID)
        throws RemoteException;
    /**
     *
     */
    public String[] remoteGetServices()
        throws RemoteException;
    /**
     *
     */
    public IServer remoteGetService(String instanceID)
        throws RemoteException;
    
    
    /**
     *
     */
    public void remoteLog(String msg)
        throws RemoteException;
    /**
     *
     */
    public void remoteLog(Exception ex)
        throws RemoteException;
    /**
     *
     */
    public void remoteError(String msg)
        throws RemoteException;
    /**
     *
     */
    public void remoteError(Exception ex)
        throws RemoteException;


    //=====================================================
    // These methods provide access for IServer
    // functionality

    /**
     *
     */
    public boolean start(long ID)
        throws RemoteException;
    /**
     *
     */
    public boolean stop(long ID)
        throws RemoteException;
    /**
     *
     */
    public boolean pause(long ID)
        throws RemoteException;
    /**
     *
     */
    public boolean resume(long ID)
        throws RemoteException;
    /**
     *
     */
    public void kill(long ID)
        throws RemoteException;
        
    /**
     *
     */
    public String getState(long ID)
        throws RemoteException;
        
    /**
     *
     */
    public String getInstanceID(long ID)
        throws RemoteException;
        
    /**
     *
     */
    public Exception getLastError(long ID)
        throws RemoteException;


    /**
     *
     */
    public ConfigProperties getConfigInfo(long ID)
        throws RemoteException;
    /**
     *
     */
    public void setConfigInfo(long ID, ConfigProperties info)
        throws RemoteException;

    
    /**
     *
     */
    public static final String RMI_LOOKUPNAME = 
        "javageeks.com/RMIServerManager:1.0.0";
}
