package com.javageeks.gjas;

import com.javageeks.classloader.ClassLoaderStrategy;
import java.util.Properties;


/**
 * This is the ServerManager interface. Any and all "public"
 * ServerManager API calls must be exposed through here.
 */
public interface IServerManager
{
    /**
     *
     */
    public void shutdown();
    

    /**
     *
     */
    public void deployService(String serviceName, 
                              ClassLoaderStrategy strategy);
    
    
    /**
     *
     */
    public IServer loadService(Service svc);
    /**
     *
     */
    public IServer loadService(String svcName);
    /**
     *
     */
    public IServer addService(Service svc, ConfigProperties args);
    /**
     *
     */
    public IServer addService(String svcName, 
                              ConfigProperties args);
    /**
     *
     */
    public void removeService(String instanceID);
    /**
     *
     */
    public void killService(String instanceID);
    /**
     *
     */
    public String[] getServices();
    /**
     *
     */
    public IServer getService(String instanceID);


    /**
     *
     */
    public void log(String msg);
    /**
     *
     */
    public void log(Exception ex);
    /**
     *
     */
    public void error(String msg);
    /**
     *
     */
    public void error(Exception ex);
}
