package com.javageeks.gjas.services;

import com.javageeks.gjas.IServer;
import com.javageeks.gjas.ServerManager;
import com.javageeks.gjas.Service;

/**
 *
 */
public interface ControlService
    extends Service
{
    /**
     * Creates a Service instance via <CODE>loader</CODE>, passing
     * in <CODE>args</CODE> to the Service.
     */
    public Server startService(String svcName, String[] args);
    /**
     * Lists all Services associated with this ControlService.
     */
    public String[] enumServiceInstances();
    /**
     * Stops a Service with the name <CODE>instance</CODE>. If no
     * instance by that name is found, nothing is done.
     */
    public void stopService(String instance);
    /**
     * Pauses a Service with the name <CODE>instance</CODE>. If no
     * instance by that name is found, nothing is done.
     */
    public void pauseService(String instance);
    /**
     * Resumes a Service with the name <CODE>instance</CODE>. If no
     * instance by that name is found, nothing is done.
     */
    public void resumeService(String instance);
}    
