package com.javageeks.gjas.services;

import java.net.Socket;
import java.io.*;
import com.javageeks.gjas.ServerManager;
import com.javageeks.gjas.connection.Connection;

/**
 *
 */
public class SocketClassLoaderConnection
    implements Connection
{
    /**
     *
     */
    public void serve(java.net.Socket socket, 
                      com.javageeks.gjas.ConfigProperties configInfo)
        throws Exception
    {
        ServerManager.instance().log(
            getClass().getName() + ".serve(): " +
            "Entered");

        InputStream in = socket.getInputStream();
        OutputStream out = socket.getOutputStream();

        BufferedReader br = new BufferedReader(new InputStreamReader(in));
        PrintWriter pw = new PrintWriter(out);

        String classname = br.readLine();
        classname =
            classname.substring(classname.indexOf(":")+1, classname.length());

        ServerManager.instance().log(
            getClass().getName() + ".serve(): " +
            "Request: " + classname);
        System.out.println("Request: " + classname);
        
        // Find the file on the disk
        try
        {
            FileInputStream inFile =
                new FileInputStream("./" + classname + ".class");

            // Tell SocketClassLoader how much data to expect
            pw.println("Content-Length:" + inFile.available());
            pw.flush();

            // We have to use OutputStream directly here, because Writer
            // and PrintWriter have no methods to write out bytes
            byte[] buffer = new byte[1024];
            int nRead = 0;
            while ((nRead = inFile.read(buffer)) != -1)
                out.write(buffer, 0, nRead);
            out.flush();

            // Write one more blank line, just for luck
            pw.write("\r\n");
        }
        catch (FileNotFoundException ex)
        {
            ServerManager.instance().log(
                getClass().getName() + ".serve(): " +
                "Error finding class file");
            ServerManager.instance().log(ex);
            
            pw.println("Error");
        }
        finally
        {
            pw.flush();
        }
    }
}    