package com.javageeks.gjas.services;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.StringTokenizer;
import java.util.Vector;
import com.javageeks.gjas.IServer;
import com.javageeks.gjas.ServerManager;
import com.javageeks.gjas.Service;

/**
 * SocketControlService:
 */
public class SocketControlService
    extends com.javageeks.gjas.services.SocketServer
{
    public void serve(Socket socket)
        throws Exception
    {
        // Set up
        BufferedReader in =
            new BufferedReader(
                new InputStreamReader(socket.getInputStream()));
        PrintWriter out = 
            new PrintWriter(socket.getOutputStream());

        // Enter the main loop
        out.print("ServerManager >");
        out.flush();
        
        for (String line = in.readLine();
            !line.equals("quit");
            line = in.readLine())
        {
            ServerManager.instance().log(this.toString() +
                ": '" + line + "'");
            if (line.trim().equals("shutdown"))
            {
                ServerManager.shutdown();
                //return;
            }
            else if (line.trim().startsWith("start "))
            {
                // Extract classname
                String currentLine = line.substring(6, line.length());
                
                if (currentLine.indexOf(" ") < 0)
                {
                    // Classname appeared by itself, so there are no
                    // additional args to parse
                    String classname = currentLine;

                    ServerManager.log(
                        getClass().getName() + ".serve(): " +
                        "Calling ServerManager.loadService(" +
                        classname + ")");
                    IServer svr = ServerManager.loadService(classname);
                    svr.start();
                }
                else
                {
                    ServerManager.log(
                        getClass().getName() + ".serve(): " +
                        "Any service started by the this service " +
                        "cannot have args; sorry.");
                }
            }
            else if (line.trim().startsWith("list"))
            {
                String[] svcs = ServerManager.getServices();
                
                out.println("Services: {");
                for (int i=0; i<svcs.length; i++)
                    out.println("    " + svcs[i]);
                out.println("}");
            }
            else if (line.trim().startsWith("remove "))
            {
                // Parse argument, confirm removal,
                // call ServerManager.removeService()
            }
            else if (line.trim().startsWith("threads"))
            {
                // List all threads running in the JVM
                //
                
                // Find the ultimate ThreadGroup parent
                ThreadGroup ancestor = Thread.currentThread().getThreadGroup();
                while (ancestor.getParent() != null)
                    ancestor = ancestor.getParent();
                    
                // List all threads
                int ct = ancestor.activeCount();
                ct += ct/2;
                Thread[] array = new Thread[ct];
                ancestor.enumerate(array, true);
                
                for (int i=0; i<array.length; i++)
                {
                    if (array[i] != null)
                    {
                        String msg = array[i].toString();
                        msg += ": [";
                        if (array[i].isAlive())
                            msg += " ALIVE";
                        if (array[i].isDaemon())
                            msg += " DAEMON";
                        msg += " ]";
                        out.println(msg);
                    }
                }
            }
            else
            {
                out.println("Unrecognized command: " + line);
            }
            
            // Print the prompt again
            out.print("ServerManager >");
            out.flush();
        }
    }
}    