package com.javageeks.net;

import java.io.*;

/**
 *
 */
public class NamedPipeOutputStream extends OutputStream
{
    // Internal members
    //
    private NamedPipe m_pipe;


    /**
     *
     */
    /*package-friendly*/ NamedPipeOutputStream(NamedPipe pipe)
    {
        m_pipe = pipe;
    }


    /**
     *
     */
    public void close()
    {
        // Do nothing--the named pipe may still be open in incoming
        // mode, so we don't want to close it
    }
    /**
     *
     */
    public void flush()
    {
        nativeFlush(m_pipe.m_hPipe);
    }
    /**
     *
     */
    public void write(byte[] b)
    {
        nativeWrite(m_pipe.m_hPipe, b);
    }
    /**
     *
     */
    public void write(int ch)
    {
        nativeWrite(m_pipe.m_hPipe, ch);
    }


    // Native methods
    //
    private static native void nativeFlush(int hPipe);
    private static native void nativeWrite(int hPipe, byte[] bytes);
    private static native void nativeWrite(int hPipe, int ch);
}
