import java.rmi.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;

/**
 * NameServer class ported to use RMI/IIOP instead of RMI/JRMP
 */
public class IIOPNameServer extends PortableRemoteObject
    implements INameServer
{
    public IIOPNameServer()
        throws java.rmi.RemoteException
    { }

    /**
     *
     */
    public String generateName()
        throws java.rmi.RemoteException
    {
        return "Fred";
    }


    /**
     *
     */
    public static void main (String args[])
        throws Exception
    {
        // Set up the InitialContext factory for JNDI
        //
        System.setProperty("java.naming.factory.initial",
                           "com.sun.jndi.cosnaming.CNCtxFactory");
        
        // Set up the JNDI Naming provider URL
        //
        System.setProperty("java.naming.provider.url",
                           "iiop://localhost:900");
        
        // Create an instance of IIOPNameServer and
        // export it
        //
        Context ctx = new InitialContext();
        INameServer ns = new IIOPNameServer();
        ctx.rebind(INameServer.RMI_BINDING_NAME, ns);

        System.out.println("IIOPNameServer bound as '" +
                           INameServer.RMI_BINDING_NAME + "'");
    }
}
