import com.javageeks.gjas.*;
import com.javageeks.gjas.services.*;

public class HeartbeatServer
{
    public static void main (String args[])
    {
        LocalServerManager lsm = new LocalServerManager();
        IServer svr = null;
        ConfigProperties props = null;

        // Start a heartbeat
        ServerManager.log("Loading HeartbeatService");
        svr = lsm.loadService("com.javageeks.gjas.services.HeartbeatService");
        props = svr.getConfigInfo();

        props.set("interval", new Integer(2 * 1000));
        props.set("port", new Integer(8080));

        svr.setConfigInfo(props);
        
        ServerManager.log("Starting service");
        svr.start();
        ServerManager.log("Service started--use localhost:8080 " +
                          "for HeartbeatListenerClient");

        // Start a LogListenerService on the heartbeat
        ServerManager.log("Loading LogListenerService");
        svr = lsm.loadService("com.javageeks.gjas.services.LogListenerService");
        props = svr.getConfigInfo();

        props.set("host", "localhost");
        props.set("port", new Integer(8080));
        props.set("file", "./LogListenerService.log");
        props.set("verbose", new Boolean(true));

        svr.setConfigInfo(props);
        
        ServerManager.log("Starting service");
        svr.start();
        ServerManager.log("Service started");
    }
}
