import java.sql.*;

public class TPHClient
{
    public static void main(String[] args)
        throws Exception
    {
        // Load the IDB driver
        Class.forName("jdbc.idbDriver").newInstance();
        
        // Make the connection
        java.util.Properties p = new java.util.Properties();
        Connection c =
            DriverManager.getConnection("jdbc:idb:sample.prp", p);

        // Set up the JDBCClassLoader to pull from class_tbl
        JDBCClassLoader jdbcClassLoader = 
            new JDBCClassLoader(c, 
                "SELECT bytecode FROM class_tbl WHERE classname = '?'");
        
        // Load the Class into the JVM
        Class cls = jdbcClassLoader.loadClass("TwoPartHello");
        Object obj = cls.newInstance();
        
        // Use Reflection to find its main() method
        // Reflect on the Class; find the method named "run" that takes
        // no arguments and returns no return value
        //
        java.lang.reflect.Method[] methods = cls.getMethods();
        for (int i=0; i<methods.length; i++)
        {
            System.out.println("Checking name of " + cls.getName()
                + "." + methods[i].getName());
            if (methods[i].getName().equals("main"))
            {
                // methods[i] is the Method that corresponds to the
                // method "void run()". Call it.
                //
                Object[] mainArgs = 
                {
                    new String[] { }
                };
                Object ret = methods[i].invoke(obj, mainArgs);
                if (ret != null)
                    System.out.println("??? main()'s not supposed to " +
                        "return me something!");
                break;
            }
        }
    }
}    