import java.io.*;
import java.util.zip.*;

/**
 *
 */
public class CompressedSerialization
{
    /**
     *
     */
    public static void main(String[] args)
        throws Exception
    {
        // Take a String, serialize it compressed to disk
        String data = "This is our test string";
        
        FileOutputStream os = 
            new FileOutputStream("data");
        GZIPOutputStream gzOS =
            new GZIPOutputStream(os);
        ObjectOutputStream oos =
            new ObjectOutputStream(gzOS);
        
        // Serialize the object
        oos.writeObject(data);
        oos.close();
        
        // Set up the input streams
        FileInputStream is =
            new FileInputStream("data");
        GZIPInputStream gzIS =
            new GZIPInputStream(is);
        ObjectInputStream ois =
            new ObjectInputStream(gzIS);
            
        String test = (String)ois.readObject();
        
        System.out.println("Compare: " + data + " vs. " + test);
        if (data.equals(test))
            System.out.println("Success!");
    }
}    