import java.io.*;
import java.sql.*;
import java.util.*;

/**
 * This code re-creates the schema for the examples used in this chapter.
 * Other JDBC-compliant databases could be used by substituting the
 * appropriate JDBC driver names and URLs in place of the IDB ones.
 */
public class CreateSchema
{
    /** 
     *
     */
    public static void main(String[] args)
        throws Exception
    {
        // Load the IDB driver
        Class.forName("jdbc.idbDriver").newInstance();
        
        //
        Properties p = new Properties();
        Connection c =
            DriverManager.getConnection("jdbc:idb:sample.prp", p);
        
        // Drop & create the table in which we will store class bytecode
        //
        Statement s = c.createStatement();
        s.executeUpdate("DROP TABLE class_tbl");
        s.close();
        
        s = c.createStatement();
        s.executeUpdate("CREATE TABLE class_tbl " +
            "( " +
                "bytecode binary, " +
                "classname varchar(80) " +
            ")");
        s.close();
    }
}    