import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class PassthroughServlet extends HttpServlet
{
    private String docRoot;

    public void init(ServletConfig config)
    {
        docRoot = config.getInitParameter("docRoot");
        if (docRoot == null)
            docRoot = ".";
    }

    public void doGet(HttpServletRequest req, 
                      HttpServletResponse res)
        throws ServletException, IOException
    {
        // Find file given on URL
        String filename = req.getServletPath();

        // Open it
        FileInputStream fis = new FileInputStream(docRoot + "/" + filename);

        // Send its contents back to the requester
        OutputStream out = res.getOutputStream();
        res.setContentType("text/html");
        int ch;
        while ((ch = fis.read()) != -1)
        {
            out.write(ch);
        }
    }
    public void doPost(HttpServletRequest req,
                       HttpServletResponse res)
        throws ServletException, IOException
    { doGet(req, res); }
}

