import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 */
public class RemoteStorageServlet
    extends HttpServlet
{
    private static final String GET = "GET";
    private static final String CHECKIN = "CHECKIN";
    private static final String CHECKOUT = "CHECKOUT";
    private static final String DIFF = "DIFF";

    protected void service(HttpServletRequest req, 
                           HttpServletResponse res)
        throws ServletException, IOException
    {
        String method = req.getMethod();

        // Get the user's map--for now, keep one map per user 
        // session; in a real robust system, we'd want to serialize
        // out the results when the session is destroyed, but
        // that's for a later date
        HttpSession session = req.getSession(true);
        Map userMap = (Map)session.getValue("MAP");
        if (userMap == null)
        {
            userMap = new HashMap();
            session.putValue("MAP", userMap);
        }

        if ("GET".equals(method))
        {
            String objName = req.getServletPath();

            Object obj = userMap.get(objName);
            if (obj == null)
            {
                String msg = "Object " + objName + " not found.";
                res.sendError(HttpServletResponse.SC_BAD_REQUEST, msg);
            }
            else
            {
                // Serialize the object
                ByteArrayOutputStream baos =
                    new ByteArrayOutputStream();
                ObjectOutputStream oos = 
                    new ObjectOutputStream(baos);

                oos.writeObject(obj);
                oos.flush();

                byte[] serializedData = baos.toByteArray();
                res.setContentLength(serializedData.length);
                res.getOutputStream().write(serializedData);
            }
        }
        else if ("CHECKIN".equals(method))
        {
            // . . . details omitted
        }
        else if ("CHECKOUT".equals(method))
        {
            // . . . details omitted
        }
        else if ("DIFF".equals(method))
        {
            // . . . details omitted
        }
    }
}
