import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.net.ServerSocket;
import java.net.Socket;
import com.javageeks.gjas.ConfigProperties;
import com.javageeks.gjas.ServerManager;

/**
 * EchoService simply echoes back the input it receives to the client.
 */
public class EchoService
    extends com.javageeks.gjas.services.ThreadedServer
    implements Runnable
{
    public void start()
        throws Exception
    {
        setRunnable(this);
        
        super.start();
    }


    public ConfigProperties getConfigInfo()
    {
        return new ConfigProperties();
    }
    public void setConfigInfo(ConfigProperties configInfo)
    {
        // Do nothing
    }


    public void run()
    {
        try
        {
            ServerSocket svrSocket = new ServerSocket(7);
            
            Socket socket;
            while ((socket = svrSocket.accept()) != null)
            {
                ServerManager.instance().log("Socket accepted");
            
                Reader fromSocket =
                    new InputStreamReader(socket.getInputStream());
                Writer toSocket =
                    new OutputStreamWriter(socket.getOutputStream());

                try
                {
                    char[] buffer = new char[1024];
                    int c;
                    while ((c = fromSocket.read(buffer)) != -1)
                    {
                        toSocket.write(buffer, 0, c);
                        toSocket.flush();
                    }
                }
                catch (Exception ex)
                { }
                
                socket.close();

                ServerManager.instance().log("Socket closed");
            }
        }
        catch (java.io.IOException ioEx)
        {
            ioEx.printStackTrace();
            return;
        }
    }
}