import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Date;
import com.javageeks.gjas.ConfigProperties;
import com.javageeks.gjas.ServerManager;
import com.javageeks.gjas.services.ThreadedServer;

/**
 * TimeService simply echoes back the input it receives to the client.
 */
public class TimeService extends ThreadedServer
    implements Runnable
{
    public void start()
        throws Exception
    {
        setRunnable(this);
        
        super.start();
    }


    public ConfigProperties getConfigInfo()
    {
        return new ConfigProperties();
    }
    public void setConfigInfo(ConfigProperties configInfo)
    {
        // Do nothing
    }


    public void run()
    {
        try
        {
            ServerSocket svrSocket = new ServerSocket(7002);
            
            Socket socket;
            while ((socket = svrSocket.accept()) != null)
            {
                ServerManager.instance().log("Socket accepted");
            
                Reader fromSocket =
                    new InputStreamReader(socket.getInputStream());
                PrintWriter toSocket =
                    new PrintWriter(
                        new OutputStreamWriter(
                            socket.getOutputStream()));
                
                toSocket.println(new Date());
                    // Date's default constructor constructs a Date
                    // with the current date/time; Date.toString()
                    // converts the date/time to readable format
                toSocket.flush();
                
                socket.close();

                ServerManager.instance().log("Socket closed");
            }
        }
        catch (java.io.IOException ioEx)
        {
            ioEx.printStackTrace();
            return;
        }
    }
}    