interface ExRunnable
{
    public void run()
        throws Throwable;
}



public class ExceptionableRunnable
    implements java.lang.Runnable
{
    public ExceptionableRunnable(ExRunnable target)
    {
        m_target = target;
    }

    public void run()
    {
        try
        {
            m_target.run();
        }
        catch (Throwable t)
        {
            thrown = t;
        }
    }
    
    public Throwable thrown = null;
    private ExRunnable m_target = null;    
    
    
    
    public static void main(String[] args)
        throws Exception
    {
        ExceptionableRunnable er =
            new ExceptionableRunnable(
                new ExRunnable()
                {
                    public void run()
                        throws Throwable
                    {
                        Thread.sleep(5*1000);
                        throw new Exception("Generic Exception");
                    }
                });
        Thread t = new Thread(er);
        t.start();
        t.join();
        
        if (er.thrown != null)
        {
            System.out.println("ExceptionableRunnable threw:");
            er.thrown.printStackTrace();
        }
    }
}    