interface FutureRunnable
{
    public Object run();
}    

public class FutureThread extends Thread
{
    public FutureThread(FutureRunnable run)
    {
        m_target = run;
        start();
    }
    
    public void run()
    {
        m_result = m_target.run();
    }
    
    public Object getResult()
        throws InterruptedException
    {
        if (Thread.currentThread() != this)
            this.join();
            
        return m_result;
    }
    public Object getResult(long timeout)
        throws InterruptedException
    {
        if (Thread.currentThread() != this)
            this.join(timeout);
            
        return m_result;
    }

    private Object m_result;    
    private FutureRunnable m_target;


    public static void main(String[] args)
        throws Exception
    {
        FutureThread ft = new FutureThread(
            new FutureRunnable()
            {
                public Object run()
                {
                    try
                    {
                        Thread.sleep(5*1000);
                        return new String("Finished!");
                    }
                    catch (InterruptedException intEx)
                    {
                        return null;
                    }
                }
            });
    
        System.out.println("OK, we're waiting now....");
        String result = (String)ft.getResult(1 * 1000);
        if (result != null)
            System.out.println("Result: " + result);
        else
            System.out.println("We didn't finish in 10 seconds.");
    }
}    