public class ScheduledThread extends Thread
{
    private ScheduledThread()
    {
        // Prevent "new ScheduledThread().start()"
        //
    }

    public ScheduledThread(Runnable runnable, java.util.Date when)
    {
        m_runnable = runnable;
        m_when = when;
    }
    
    public void run()
    {
        try
        {
            // Make sure "when" is after now.
            //
            while (m_when.after(new java.util.Date()))
            {
                Thread.sleep(1000);
            }

            // If the above test failed, it's time
            // to run our target
            //            
            m_runnable.run();
        }
        catch (InterruptedException intEx)
        {
            return;
        }
    }
    
    private java.util.Date m_when;
    private Runnable m_runnable;
}    