import java.util.Enumeration;
import java.util.Vector;

interface ExceptionListener
{
    public void exceptionThrown(Thread t, Throwable e);
}    

public class ThreadGroupEx extends ThreadGroup
{
    public ThreadGroupEx(String name)
    {
        super(name);
    }
    public ThreadGroupEx(ThreadGroup parent, String name)
    {
        super(parent, name);
    }
    
    public void registerListener(ExceptionListener l)
    {
        m_listeners.add(l);
    }
    public void removeListener(ExceptionListener l)
    {
        m_listeners.remove(l);
    }
    
    public void uncaughtException(Thread t, Throwable e)
    {
        for (Enumeration enum = m_listeners.elements();
            enum.hasMoreElements(); )
        {
            ExceptionListener el = (ExceptionListener)enum.nextElement();
            
            el.exceptionThrown(t, e);
        }
        
        super.uncaughtException(t, e);
    }
    
    private Vector m_listeners = new Vector();
}    